"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ = require("./..");

var CollapseButton = function CollapseButton(props) {
  var collapse = props.collapse,
      alignment = props.alignment,
      onClick = props.onClick,
      className = props.className,
      otherProps = (0, _objectWithoutProperties2.default)(props, ["collapse", "alignment", "onClick", "className"]);

  var handleClick = function handleClick() {
    onClick && onClick();
  };

  var getIconName = function getIconName() {
    return collapse ? 'arrow-right-optical_14' : 'arrow-left-optical_14';
  };

  return _react.default.createElement(_.Button, (0, _extends2.default)({
    ariaLabel: collapse ? 'expand' : 'collapse',
    className: 'cui-collapse-button' + (" cui-collapse-button--" + alignment) + ("" + (className && " " + className || '')),
    children: _react.default.createElement(_.Icon, {
      name: getIconName()
    }),
    onClick: function onClick() {
      return handleClick();
    }
  }, otherProps));
};

CollapseButton.displayName = 'CollapseButton';
CollapseButton.defaultProps = {
  collapse: true,
  alignment: 'left',
  onClick: null,
  className: ''
};
CollapseButton.propTypes = {
  collapse: _propTypes.default.bool,
  alignment: _propTypes.default.oneOf(['left', 'right', 'top', 'bottom']),
  onClick: _propTypes.default.func,
  className: _propTypes.default.string
};
var _default = CollapseButton;
exports.default = _default;
module.exports = exports["default"];