"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

/**
 * @category layout
 * @component footer
 * @variations collab-ui-react
 */
var Footer =
/*#__PURE__*/
function (_React$Component) {
  function Footer() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Footer.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        color = _this$props.color,
        logo = _this$props.logo,
        copyright = _this$props.copyright,
        social = _this$props.social,
        className = _this$props.className,
        children = _this$props.children;

    var footerTopSection = children && _react.default.createElement("section", {
      className: "cui-footer__top"
    }, children);

    var footerBottomSection = (logo || copyright || social) && _react.default.createElement("section", {
      className: "cui-footer__bottom"
    }, (logo || copyright) && _react.default.createElement("span", {
      className: "cui-footer__bottom--position-left"
    }, logo, " ", copyright), social && _react.default.createElement("span", {
      className: "cui-footer__bottom--position-right"
    }, social));

    return _react.default.createElement("footer", {
      className: "cui-footer" + (" cui-footer--" + color) + (" " + className)
    }, footerTopSection, footerBottomSection);
  };

  (0, _inheritsLoose2.default)(Footer, _React$Component);
  return Footer;
}(_react.default.Component);

exports.default = Footer;
Footer.displayName = 'Footer';
Footer.propTypes = {
  color: _propTypes.default.string,
  logo: _propTypes.default.node,
  copyright: _propTypes.default.string,
  social: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.node
};
Footer.defaultProps = {
  color: 'dark',
  logo: null,
  copyright: '',
  social: '',
  className: '',
  children: null
};
/**
* @name Footer
* @description default footer
*
* @category layout
* @component footer
* @section default
*
* @js
import { Icon, List, ListItem } from '@collab-ui/react';

export default class DefaultFooter extends React.PureComponent {
  render() {
    const copyright = '2018 Cisco and /or its affiliate';

    return (
      <div className='row'>
        <Footer
          logo={<Icon name='icon-spark_16' />}
          copyright=''
          social=''
        >
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Connect</h5>
            <List>
              <ListItem label='24/7 Support' />
              <ListItem label='Developer Events' />
              <ListItem label='Contact Sales' />
            </List>
          </div>
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Handy Links</h5>
            <List>
              <ListItem label='Cisco Webex Ambassadors' />
              <ListItem label='Cisco Webex Control Hub' />
              <ListItem label='Cisco Webex Innovation Fund' />
            </List>
          </div>
          <div className='columns medium-3'>
            <h5 className='cui-footer__list-item-title'>Resources</h5>
            <List>
              <ListItem label='Open Source Bot Starter Kits' />
              <ListItem label='Download Cisco Webex Teams' />
              <ListItem label='Devnet Learning Labs' />
            </List>
          </div>
          <div className='columns medium-3'>
            <List>
              <ListItem label='Terms Of Service' />
              <ListItem label='Privacy Policy' />
              <ListItem label='Cookie Policy' />
              <ListItem label='Trademarks' />
            </List>
          </div>
        </Footer>
      </div>
    );
  }
}
**/

module.exports = exports["default"];