"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _2 = require("./..");

var _lodash = _interopRequireDefault(require("lodash"));

/**
 * @category containers
 * @component list-item
 * @variations collab-ui-react
 */
var ListItemHeader =
/*#__PURE__*/
function (_React$PureComponent) {
  function ListItemHeader() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this, _this.state = {
      id: _lodash.default.uniqueId(_this.props.id && _this.props.id + "-" || 'cui-space-list-item__header-')
    }, _temp) || (0, _assertThisInitialized2.default)(_this);
  }

  var _proto = ListItemHeader.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        children = _this$props.children,
        header = _this$props.header,
        props = (0, _objectWithoutProperties2.default)(_this$props, ["className", "children", "header"]);
    var id = this.state.id;
    var staticChildren = [_react.default.createElement(_2.ListItemSection, {
      key: "child-0",
      position: "center"
    }, _react.default.createElement("div", {
      className: 'cui-list-item__header'
    }, header)), _react.default.createElement(_2.ListItemSection, {
      key: "child-1",
      position: "right"
    }, children)];
    return _react.default.createElement(_2.ListItem, (0, _extends2.default)({
      className: 'cui-list-item-header' + ("" + (className && " " + className || '')),
      id: id,
      tabIndex: -1,
      onClick: function onClick() {
        return false;
      },
      onKeyDown: function onKeyDown() {
        return false;
      },
      focusable: false
    }, props), staticChildren);
  };

  (0, _inheritsLoose2.default)(ListItemHeader, _React$PureComponent);
  return ListItemHeader;
}(_react.default.PureComponent);

exports.default = ListItemHeader;
ListItemHeader.displayName = 'ListItemHeader';
ListItemHeader.defaultProps = {
  className: '',
  children: null,
  id: '',
  isReadOnly: true
};
ListItemHeader.propTypes = {
  /** HTML Class for associated input */
  className: _propTypes.default.string,

  /** ListItemHeader Children */
  children: _propTypes.default.node,

  /** ListItem header */
  header: _propTypes.default.string.isRequired,

  /** HTML ID for associated input */
  id: _propTypes.default.string,

  /** ListItemHeader Bool */
  isReadOnly: _propTypes.default.bool
};
/**
* @name List Item Header
*
* @category containers
* @component list-item
* @section header
*
* @js
*
import { List, ListItemHeader } from '@collab-ui/react';
import { NavLink } from 'react-router-dom';

export default class SpaceListExamples extends React.PureComponent {

  render() {
    const anchorNode = <NavLink to='/containers/list-item'>More</NavLink>;
    return(
      <div className="medium-4 columns">
        <List>
          <ListItemHeader header='Testing' children={anchorNode} />
        </List>
        <List className='cui--dark' style={{backgroundColor: 'rgba(40,40,40,0.72)'}}>
          <ListItemHeader header='Testing' children={anchorNode}/>
        </List>
      </div>
    );
  }
}
**/

module.exports = exports["default"];