"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("../Input"));

var _Icon = _interopRequireDefault(require("../Icon"));

/**
 * @category controls
 * @component search-input
 * @variations collab-ui-react
*/
var SearchInput = function SearchInput(props) {
  var type = props.type,
      otherProps = (0, _objectWithoutProperties2.default)(props, ["type"]);
  return _react.default.createElement(_Input.default, (0, _extends2.default)({
    className: "" + (type === 'pill' ? 'cui-search-input--pill' : 'cui-search-input')
  }, otherProps), _react.default.createElement(_Icon.default, {
    name: "" + (type === 'pill' ? 'search_16' : 'search_20'),
    isAria: false
  }));
};

SearchInput.displayName = 'SearchInput';
SearchInput.defaultProps = {
  type: 'normal'
};
SearchInput.propTypes = {
  /** style of search input normal or pill */
  type: _propTypes.default.oneOf(['normal', 'pill'])
};
var _default = SearchInput;
/**
* @name Normal Search Input
* @description Search inputs allow the user to input search text.
*
* @category controls
* @component search-input
* @section default
*
* @js

export default class DefaultSearchInput extends React.PureComponent {
  render() {
    return (
      <div className='row'>
        <SearchInput
          name='defaultSearchInput'
          htmlId='defaultSearchInput'
          inputSize='small-5'
        />
      </div>
    );
  }
}

**/

/**
* @name Pill Search Input
* @description To use the pill style search input, set <code>type='pill'</code>.
*
* @category controls
* @component search-input
* @section pill
*
* @js

export default class PillSearchInput extends React.PureComponent {
  render() {
    return (
      <div className='row'>
        <SearchInput
          name='pillSearchInput'
          htmlId='pillSearchInput'
          type='pill'
          inputSize='small-5'
        />
      </div>
    );
  }
}

**/

exports.default = _default;
module.exports = exports["default"];