"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _ListItem = _interopRequireDefault(require("../ListItem"));

var _ListItemSection = _interopRequireDefault(require("../ListItemSection"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _lodash = _interopRequireDefault(require("lodash"));

/**
 * @category containers
 * @component select-option
 * @variations collab-ui-react
 */
var SelectOption =
/*#__PURE__*/
function (_React$Component) {
  function SelectOption() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      id: _lodash.default.uniqueId(_this.props.id && _this.props.id + "-" || 'cui-select-option-')
    }, _temp) || (0, _assertThisInitialized2.default)(_this);
  }

  var _proto = SelectOption.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        isMulti = _this$props.isMulti,
        active = _this$props.active,
        children = _this$props.children,
        label = _this$props.label,
        props = (0, _objectWithoutProperties2.default)(_this$props, ["className", "isMulti", "active", "children", "label"]);
    var id = this.state.id;
    var separateChildren = isMulti ? _react.default.createElement(_Checkbox.default, {
      htmlId: id + "__checkbox",
      label: label,
      checked: active,
      onChange: function onChange() {}
    }) : [_react.default.createElement(_ListItemSection.default, {
      key: "child-0",
      position: "center"
    }, label || children), _react.default.createElement(_ListItemSection.default, {
      key: "child-1",
      position: "right"
    }, active && _react.default.createElement(_Icon.default, {
      color: "blue",
      name: "check_20"
    }))];
    return _react.default.createElement(_ListItem.default, (0, _extends2.default)({
      className: "" + (className && " " + className || ''),
      id: id
    }, props), separateChildren);
  };

  (0, _inheritsLoose2.default)(SelectOption, _React$Component);
  return SelectOption;
}(_react.default.Component);

exports.default = SelectOption;
SelectOption.displayName = 'SelectOption';
SelectOption.defaultProps = {
  active: false,
  children: null,
  className: '',
  id: '',
  isMulti: false,
  label: ''
};
SelectOption.propTypes = {
  /** SelectOption Boolean that describes active state */
  active: _propTypes.default.bool,

  /** SelectOption Children */
  children: _propTypes.default.node,

  /** HTML Class for ListItem */
  className: _propTypes.default.string,

  /** SelectOption id */
  id: _propTypes.default.string,

  /** SelectOption Boolean that modifies adds checkboxes */
  isMulti: _propTypes.default.bool,

  /** SelectOption string alternative to children nodes */
  label: _propTypes.default.string
};
module.exports = exports["default"];