"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

/**
 * Tab is supplemental, non-clickable component used to help bring attention to an item or object.
 * @param props
 * @returns {XML}
 * @constructor
 */
var TabPane = function TabPane(props) {
  var children = props.children,
      active = props.active;
  return _react.default.createElement("div", {
    className: "cui-tab__pane" + ("" + (active ? ' active' : ''))
  }, _react.default.createElement("div", {
    className: "cui-tab__content"
  }, children));
};

TabPane.propTypes = {
  /**
   * optional children prop type
   */
  children: _propTypes.default.node,

  /**
   * optional active prop type
   */
  active: _propTypes.default.bool
};
TabPane.defaultProps = {
  active: false
};
TabPane.displayName = 'TabPane';
var _default = TabPane;
exports.default = _default;
module.exports = exports["default"];